// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/spanner/admin/instance/v1/spanner_instance_admin.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fspanner_2fadmin_2finstance_2fv1_2fspanner_5finstance_5fadmin_2eproto__INCLUDED
#define GRPC_google_2fspanner_2fadmin_2finstance_2fv1_2fspanner_5finstance_5fadmin_2eproto__INCLUDED

#include "google/spanner/admin/instance/v1/spanner_instance_admin.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace google {
namespace spanner {
namespace admin {
namespace instance {
namespace v1 {

// Cloud Spanner Instance Admin API
//
// The Cloud Spanner Instance Admin API can be used to create, delete,
// modify and list instances. Instances are dedicated Cloud Spanner serving
// and storage resources to be used by Cloud Spanner databases.
//
// Each instance has a "configuration", which dictates where the
// serving resources for the Cloud Spanner instance are located (e.g.,
// US-central, Europe). Configurations are created by Google based on
// resource availability.
//
// Cloud Spanner billing is based on the instances that exist and their
// sizes. After an instance exists, there are no additional
// per-database or per-operation charges for use of the instance
// (though there may be additional network bandwidth charges).
// Instances offer isolation: problems with databases in one instance
// will not affect other instances. However, within an instance
// databases can affect each other. For example, if one database in an
// instance receives a lot of requests and consumes most of the
// instance resources, fewer resources are available for other
// databases in that instance, and their performance may suffer.
class InstanceAdmin final {
 public:
  static constexpr char const* service_full_name() {
    return "google.spanner.admin.instance.v1.InstanceAdmin";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the supported instance configurations for a given project.
    virtual ::grpc::Status ListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>> AsyncListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>>(AsyncListInstanceConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>> PrepareAsyncListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>>(PrepareAsyncListInstanceConfigsRaw(context, request, cq));
    }
    // Gets information about a particular instance configuration.
    virtual ::grpc::Status GetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::google::spanner::admin::instance::v1::InstanceConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstanceConfig>> AsyncGetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstanceConfig>>(AsyncGetInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstanceConfig>> PrepareAsyncGetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstanceConfig>>(PrepareAsyncGetInstanceConfigRaw(context, request, cq));
    }
    // Creates an instance configuration and begins preparing it to be used. The
    // returned [long-running operation][google.longrunning.Operation]
    // can be used to track the progress of preparing the new
    // instance configuration. The instance configuration name is assigned by the
    // caller. If the named instance configuration already exists,
    // `CreateInstanceConfig` returns `ALREADY_EXISTS`.
    //
    // Immediately after the request returns:
    //
    //   * The instance configuration is readable via the API, with all requested
    //     attributes. The instance configuration's
    //     [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //     field is set to true. Its state is `CREATING`.
    //
    // While the operation is pending:
    //
    //   * Cancelling the operation renders the instance configuration immediately
    //     unreadable via the API.
    //   * Except for deleting the creating resource, all other attempts to modify
    //     the instance configuration are rejected.
    //
    // Upon completion of the returned operation:
    //
    //   * Instances can be created using the instance configuration.
    //   * The instance configuration's
    //   [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //   field becomes false. Its state becomes `READY`.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_config_name>/operations/<operation_id>` and can be used to track
    // creation of the instance configuration. The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [CreateInstanceConfigMetadata][google.spanner.admin.instance.v1.CreateInstanceConfigMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstanceConfig][google.spanner.admin.instance.v1.InstanceConfig], if
    // successful.
    //
    // Authorization requires `spanner.instanceConfigs.create` permission on
    // the resource
    // [parent][google.spanner.admin.instance.v1.CreateInstanceConfigRequest.parent].
    virtual ::grpc::Status CreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceConfigRaw(context, request, cq));
    }
    // Updates an instance configuration. The returned
    // [long-running operation][google.longrunning.Operation] can be used to track
    // the progress of updating the instance. If the named instance configuration
    // does not exist, returns `NOT_FOUND`.
    //
    // Only user-managed configurations can be updated.
    //
    // Immediately after the request returns:
    //
    //   * The instance configuration's
    //     [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //     field is set to true.
    //
    // While the operation is pending:
    //
    //   * Cancelling the operation sets its metadata's
    //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstanceConfigMetadata.cancel_time].
    //     The operation is guaranteed to succeed at undoing all changes, after
    //     which point it terminates with a `CANCELLED` status.
    //   * All other attempts to modify the instance configuration are rejected.
    //   * Reading the instance configuration via the API continues to give the
    //     pre-request values.
    //
    // Upon completion of the returned operation:
    //
    //   * Creating instances using the instance configuration uses the new
    //     values.
    //   * The new values of the instance configuration are readable via the API.
    //   * The instance configuration's
    //   [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //   field becomes false.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_config_name>/operations/<operation_id>` and can be used to track
    // the instance configuration modification.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [UpdateInstanceConfigMetadata][google.spanner.admin.instance.v1.UpdateInstanceConfigMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstanceConfig][google.spanner.admin.instance.v1.InstanceConfig], if
    // successful.
    //
    // Authorization requires `spanner.instanceConfigs.update` permission on
    // the resource [name][google.spanner.admin.instance.v1.InstanceConfig.name].
    virtual ::grpc::Status UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    // Deletes the instance configuration. Deletion is only allowed when no
    // instances are using the configuration. If any instances are using
    // the configuration, returns `FAILED_PRECONDITION`.
    //
    // Only user-managed configurations can be deleted.
    //
    // Authorization requires `spanner.instanceConfigs.delete` permission on
    // the resource [name][google.spanner.admin.instance.v1.InstanceConfig.name].
    virtual ::grpc::Status DeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteInstanceConfigRaw(context, request, cq));
    }
    // Lists the user-managed instance configuration [long-running
    // operations][google.longrunning.Operation] in the given project. An instance
    // configuration operation has a name of the form
    // `projects/<project>/instanceConfigs/<instance_config>/operations/<operation>`.
    // The long-running operation
    // [metadata][google.longrunning.Operation.metadata] field type
    // `metadata.type_url` describes the type of the metadata. Operations returned
    // include those that have completed/failed/canceled within the last 7 days,
    // and pending operations. Operations returned are ordered by
    // `operation.metadata.value.start_time` in descending order starting
    // from the most recently started operation.
    virtual ::grpc::Status ListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>> AsyncListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>>(AsyncListInstanceConfigOperationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>> PrepareAsyncListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>>(PrepareAsyncListInstanceConfigOperationsRaw(context, request, cq));
    }
    // Lists all instances in the given project.
    virtual ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    // Lists all instance partitions for the given instance.
    virtual ::grpc::Status ListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>> AsyncListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>>(AsyncListInstancePartitionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>> PrepareAsyncListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>>(PrepareAsyncListInstancePartitionsRaw(context, request, cq));
    }
    // Gets information about a particular instance.
    virtual ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::google::spanner::admin::instance::v1::Instance* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    // Creates an instance and begins preparing it to begin serving. The
    // returned [long-running operation][google.longrunning.Operation]
    // can be used to track the progress of preparing the new
    // instance. The instance name is assigned by the caller. If the
    // named instance already exists, `CreateInstance` returns
    // `ALREADY_EXISTS`.
    //
    // Immediately upon completion of this request:
    //
    //   * The instance is readable via the API, with all requested attributes
    //     but no allocated resources. Its state is `CREATING`.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation renders the instance immediately unreadable
    //     via the API.
    //   * The instance can be deleted.
    //   * All other attempts to modify the instance are rejected.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing for all successfully-allocated resources begins (some types
    //     may have lower than the requested levels).
    //   * Databases can be created in the instance.
    //   * The instance's allocated resource levels are readable via the API.
    //   * The instance's state becomes `READY`.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format `<instance_name>/operations/<operation_id>` and
    // can be used to track creation of the instance.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [CreateInstanceMetadata][google.spanner.admin.instance.v1.CreateInstanceMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [Instance][google.spanner.admin.instance.v1.Instance], if successful.
    virtual ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    // Updates an instance, and begins allocating or releasing resources
    // as requested. The returned [long-running
    // operation][google.longrunning.Operation] can be used to track the
    // progress of updating the instance. If the named instance does not
    // exist, returns `NOT_FOUND`.
    //
    // Immediately upon completion of this request:
    //
    //   * For resource types for which a decrease in the instance's allocation
    //     has been requested, billing is based on the newly-requested level.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation sets its metadata's
    //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstanceMetadata.cancel_time],
    //     and begins restoring resources to their pre-request values. The
    //     operation is guaranteed to succeed at undoing all resource changes,
    //     after which point it terminates with a `CANCELLED` status.
    //   * All other attempts to modify the instance are rejected.
    //   * Reading the instance via the API continues to give the pre-request
    //     resource levels.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing begins for all successfully-allocated resources (some types
    //     may have lower than the requested levels).
    //   * All newly-reserved resources are available for serving the instance's
    //     tables.
    //   * The instance's new resource levels are readable via the API.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format `<instance_name>/operations/<operation_id>` and
    // can be used to track the instance modification.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [UpdateInstanceMetadata][google.spanner.admin.instance.v1.UpdateInstanceMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [Instance][google.spanner.admin.instance.v1.Instance], if successful.
    //
    // Authorization requires `spanner.instances.update` permission on
    // the resource [name][google.spanner.admin.instance.v1.Instance.name].
    virtual ::grpc::Status UpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceRaw(context, request, cq));
    }
    // Deletes an instance.
    //
    // Immediately upon completion of the request:
    //
    //   * Billing ceases for all of the instance's reserved resources.
    //
    // Soon afterward:
    //
    //   * The instance and *all of its databases* immediately and
    //     irrevocably disappear from the API. All data in the databases
    //     is permanently deleted.
    virtual ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    // Sets the access control policy on an instance resource. Replaces any
    // existing policy.
    //
    // Authorization requires `spanner.instances.setIamPolicy` on
    // [resource][google.iam.v1.SetIamPolicyRequest.resource].
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Gets the access control policy for an instance resource. Returns an empty
    // policy if an instance exists but does not have a policy set.
    //
    // Authorization requires `spanner.instances.getIamPolicy` on
    // [resource][google.iam.v1.GetIamPolicyRequest.resource].
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Returns permissions that the caller has on the specified instance resource.
    //
    // Attempting this RPC on a non-existent Cloud Spanner instance resource will
    // result in a NOT_FOUND error if the user has `spanner.instances.list`
    // permission on the containing Google Cloud Project. Otherwise returns an
    // empty set of permissions.
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    // Gets information about a particular instance partition.
    virtual ::grpc::Status GetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::google::spanner::admin::instance::v1::InstancePartition* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstancePartition>> AsyncGetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstancePartition>>(AsyncGetInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstancePartition>> PrepareAsyncGetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstancePartition>>(PrepareAsyncGetInstancePartitionRaw(context, request, cq));
    }
    // Creates an instance partition and begins preparing it to be used. The
    // returned [long-running operation][google.longrunning.Operation]
    // can be used to track the progress of preparing the new instance partition.
    // The instance partition name is assigned by the caller. If the named
    // instance partition already exists, `CreateInstancePartition` returns
    // `ALREADY_EXISTS`.
    //
    // Immediately upon completion of this request:
    //
    //   * The instance partition is readable via the API, with all requested
    //     attributes but no allocated resources. Its state is `CREATING`.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation renders the instance partition immediately
    //     unreadable via the API.
    //   * The instance partition can be deleted.
    //   * All other attempts to modify the instance partition are rejected.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing for all successfully-allocated resources begins (some types
    //     may have lower than the requested levels).
    //   * Databases can start using this instance partition.
    //   * The instance partition's allocated resource levels are readable via the
    //     API.
    //   * The instance partition's state becomes `READY`.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_partition_name>/operations/<operation_id>` and can be used to
    // track creation of the instance partition.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstancePartition][google.spanner.admin.instance.v1.InstancePartition], if
    // successful.
    virtual ::grpc::Status CreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInstancePartitionRaw(context, request, cq));
    }
    // Deletes an existing instance partition. Requires that the
    // instance partition is not used by any database or backup and is not the
    // default instance partition of an instance.
    //
    // Authorization requires `spanner.instancePartitions.delete` permission on
    // the resource
    // [name][google.spanner.admin.instance.v1.InstancePartition.name].
    virtual ::grpc::Status DeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteInstancePartitionRaw(context, request, cq));
    }
    // Updates an instance partition, and begins allocating or releasing resources
    // as requested. The returned [long-running
    // operation][google.longrunning.Operation] can be used to track the
    // progress of updating the instance partition. If the named instance
    // partition does not exist, returns `NOT_FOUND`.
    //
    // Immediately upon completion of this request:
    //
    //   * For resource types for which a decrease in the instance partition's
    //   allocation has been requested, billing is based on the newly-requested
    //   level.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation sets its metadata's
    //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstancePartitionMetadata.cancel_time],
    //     and begins restoring resources to their pre-request values. The
    //     operation is guaranteed to succeed at undoing all resource changes,
    //     after which point it terminates with a `CANCELLED` status.
    //   * All other attempts to modify the instance partition are rejected.
    //   * Reading the instance partition via the API continues to give the
    //     pre-request resource levels.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing begins for all successfully-allocated resources (some types
    //     may have lower than the requested levels).
    //   * All newly-reserved resources are available for serving the instance
    //     partition's tables.
    //   * The instance partition's new resource levels are readable via the API.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_partition_name>/operations/<operation_id>` and can be used to
    // track the instance partition modification. The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [UpdateInstancePartitionMetadata][google.spanner.admin.instance.v1.UpdateInstancePartitionMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstancePartition][google.spanner.admin.instance.v1.InstancePartition], if
    // successful.
    //
    // Authorization requires `spanner.instancePartitions.update` permission on
    // the resource
    // [name][google.spanner.admin.instance.v1.InstancePartition.name].
    virtual ::grpc::Status UpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstancePartitionRaw(context, request, cq));
    }
    // Lists instance partition [long-running
    // operations][google.longrunning.Operation] in the given instance.
    // An instance partition operation has a name of the form
    // `projects/<project>/instances/<instance>/instancePartitions/<instance_partition>/operations/<operation>`.
    // The long-running operation
    // [metadata][google.longrunning.Operation.metadata] field type
    // `metadata.type_url` describes the type of the metadata. Operations returned
    // include those that have completed/failed/canceled within the last 7 days,
    // and pending operations. Operations returned are ordered by
    // `operation.metadata.value.start_time` in descending order starting from the
    // most recently started operation.
    //
    // Authorization requires `spanner.instancePartitionOperations.list`
    // permission on the resource
    // [parent][google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest.parent].
    virtual ::grpc::Status ListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>> AsyncListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>>(AsyncListInstancePartitionOperationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>> PrepareAsyncListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>>(PrepareAsyncListInstancePartitionOperationsRaw(context, request, cq));
    }
    // Moves an instance to the target instance configuration. You can use the
    // returned [long-running operation][google.longrunning.Operation] to track
    // the progress of moving the instance.
    //
    // `MoveInstance` returns `FAILED_PRECONDITION` if the instance meets any of
    // the following criteria:
    //
    //   * Is undergoing a move to a different instance configuration
    //   * Has backups
    //   * Has an ongoing update
    //   * Contains any CMEK-enabled databases
    //   * Is a free trial instance
    //
    // While the operation is pending:
    //
    //   * All other attempts to modify the instance, including changes to its
    //     compute capacity, are rejected.
    //   * The following database and backup admin operations are rejected:
    //
    //     * `DatabaseAdmin.CreateDatabase`
    //     * `DatabaseAdmin.UpdateDatabaseDdl` (disabled if default_leader is
    //        specified in the request.)
    //     * `DatabaseAdmin.RestoreDatabase`
    //     * `DatabaseAdmin.CreateBackup`
    //     * `DatabaseAdmin.CopyBackup`
    //
    //   * Both the source and target instance configurations are subject to
    //     hourly compute and storage charges.
    //   * The instance might experience higher read-write latencies and a higher
    //     transaction abort rate. However, moving an instance doesn't cause any
    //     downtime.
    //
    // The returned [long-running operation][google.longrunning.Operation] has
    // a name of the format
    // `<instance_name>/operations/<operation_id>` and can be used to track
    // the move instance operation. The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [MoveInstanceMetadata][google.spanner.admin.instance.v1.MoveInstanceMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [Instance][google.spanner.admin.instance.v1.Instance],
    // if successful.
    // Cancelling the operation sets its metadata's
    // [cancel_time][google.spanner.admin.instance.v1.MoveInstanceMetadata.cancel_time].
    // Cancellation is not immediate because it involves moving any data
    // previously moved to the target instance configuration back to the original
    // instance configuration. You can use this operation to track the progress of
    // the cancellation. Upon successful completion of the cancellation, the
    // operation terminates with `CANCELLED` status.
    //
    // If not cancelled, upon completion of the returned operation:
    //
    //   * The instance successfully moves to the target instance
    //     configuration.
    //   * You are billed for compute and storage in target instance
    //   configuration.
    //
    // Authorization requires the `spanner.instances.update` permission on
    // the resource [instance][google.spanner.admin.instance.v1.Instance].
    //
    // For more details, see
    // [Move an instance](https://cloud.google.com/spanner/docs/move-instance).
    virtual ::grpc::Status MoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncMoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncMoveInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncMoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncMoveInstanceRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the supported instance configurations for a given project.
      virtual void ListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information about a particular instance configuration.
      virtual void GetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* request, ::google::spanner::admin::instance::v1::InstanceConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* request, ::google::spanner::admin::instance::v1::InstanceConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an instance configuration and begins preparing it to be used. The
      // returned [long-running operation][google.longrunning.Operation]
      // can be used to track the progress of preparing the new
      // instance configuration. The instance configuration name is assigned by the
      // caller. If the named instance configuration already exists,
      // `CreateInstanceConfig` returns `ALREADY_EXISTS`.
      //
      // Immediately after the request returns:
      //
      //   * The instance configuration is readable via the API, with all requested
      //     attributes. The instance configuration's
      //     [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
      //     field is set to true. Its state is `CREATING`.
      //
      // While the operation is pending:
      //
      //   * Cancelling the operation renders the instance configuration immediately
      //     unreadable via the API.
      //   * Except for deleting the creating resource, all other attempts to modify
      //     the instance configuration are rejected.
      //
      // Upon completion of the returned operation:
      //
      //   * Instances can be created using the instance configuration.
      //   * The instance configuration's
      //   [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
      //   field becomes false. Its state becomes `READY`.
      //
      // The returned [long-running operation][google.longrunning.Operation] will
      // have a name of the format
      // `<instance_config_name>/operations/<operation_id>` and can be used to track
      // creation of the instance configuration. The
      // [metadata][google.longrunning.Operation.metadata] field type is
      // [CreateInstanceConfigMetadata][google.spanner.admin.instance.v1.CreateInstanceConfigMetadata].
      // The [response][google.longrunning.Operation.response] field type is
      // [InstanceConfig][google.spanner.admin.instance.v1.InstanceConfig], if
      // successful.
      //
      // Authorization requires `spanner.instanceConfigs.create` permission on
      // the resource
      // [parent][google.spanner.admin.instance.v1.CreateInstanceConfigRequest.parent].
      virtual void CreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an instance configuration. The returned
      // [long-running operation][google.longrunning.Operation] can be used to track
      // the progress of updating the instance. If the named instance configuration
      // does not exist, returns `NOT_FOUND`.
      //
      // Only user-managed configurations can be updated.
      //
      // Immediately after the request returns:
      //
      //   * The instance configuration's
      //     [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
      //     field is set to true.
      //
      // While the operation is pending:
      //
      //   * Cancelling the operation sets its metadata's
      //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstanceConfigMetadata.cancel_time].
      //     The operation is guaranteed to succeed at undoing all changes, after
      //     which point it terminates with a `CANCELLED` status.
      //   * All other attempts to modify the instance configuration are rejected.
      //   * Reading the instance configuration via the API continues to give the
      //     pre-request values.
      //
      // Upon completion of the returned operation:
      //
      //   * Creating instances using the instance configuration uses the new
      //     values.
      //   * The new values of the instance configuration are readable via the API.
      //   * The instance configuration's
      //   [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
      //   field becomes false.
      //
      // The returned [long-running operation][google.longrunning.Operation] will
      // have a name of the format
      // `<instance_config_name>/operations/<operation_id>` and can be used to track
      // the instance configuration modification.  The
      // [metadata][google.longrunning.Operation.metadata] field type is
      // [UpdateInstanceConfigMetadata][google.spanner.admin.instance.v1.UpdateInstanceConfigMetadata].
      // The [response][google.longrunning.Operation.response] field type is
      // [InstanceConfig][google.spanner.admin.instance.v1.InstanceConfig], if
      // successful.
      //
      // Authorization requires `spanner.instanceConfigs.update` permission on
      // the resource [name][google.spanner.admin.instance.v1.InstanceConfig.name].
      virtual void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the instance configuration. Deletion is only allowed when no
      // instances are using the configuration. If any instances are using
      // the configuration, returns `FAILED_PRECONDITION`.
      //
      // Only user-managed configurations can be deleted.
      //
      // Authorization requires `spanner.instanceConfigs.delete` permission on
      // the resource [name][google.spanner.admin.instance.v1.InstanceConfig.name].
      virtual void DeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the user-managed instance configuration [long-running
      // operations][google.longrunning.Operation] in the given project. An instance
      // configuration operation has a name of the form
      // `projects/<project>/instanceConfigs/<instance_config>/operations/<operation>`.
      // The long-running operation
      // [metadata][google.longrunning.Operation.metadata] field type
      // `metadata.type_url` describes the type of the metadata. Operations returned
      // include those that have completed/failed/canceled within the last 7 days,
      // and pending operations. Operations returned are ordered by
      // `operation.metadata.value.start_time` in descending order starting
      // from the most recently started operation.
      virtual void ListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all instances in the given project.
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest* request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest* request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all instance partitions for the given instance.
      virtual void ListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information about a particular instance.
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest* request, ::google::spanner::admin::instance::v1::Instance* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest* request, ::google::spanner::admin::instance::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an instance and begins preparing it to begin serving. The
      // returned [long-running operation][google.longrunning.Operation]
      // can be used to track the progress of preparing the new
      // instance. The instance name is assigned by the caller. If the
      // named instance already exists, `CreateInstance` returns
      // `ALREADY_EXISTS`.
      //
      // Immediately upon completion of this request:
      //
      //   * The instance is readable via the API, with all requested attributes
      //     but no allocated resources. Its state is `CREATING`.
      //
      // Until completion of the returned operation:
      //
      //   * Cancelling the operation renders the instance immediately unreadable
      //     via the API.
      //   * The instance can be deleted.
      //   * All other attempts to modify the instance are rejected.
      //
      // Upon completion of the returned operation:
      //
      //   * Billing for all successfully-allocated resources begins (some types
      //     may have lower than the requested levels).
      //   * Databases can be created in the instance.
      //   * The instance's allocated resource levels are readable via the API.
      //   * The instance's state becomes `READY`.
      //
      // The returned [long-running operation][google.longrunning.Operation] will
      // have a name of the format `<instance_name>/operations/<operation_id>` and
      // can be used to track creation of the instance.  The
      // [metadata][google.longrunning.Operation.metadata] field type is
      // [CreateInstanceMetadata][google.spanner.admin.instance.v1.CreateInstanceMetadata].
      // The [response][google.longrunning.Operation.response] field type is
      // [Instance][google.spanner.admin.instance.v1.Instance], if successful.
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an instance, and begins allocating or releasing resources
      // as requested. The returned [long-running
      // operation][google.longrunning.Operation] can be used to track the
      // progress of updating the instance. If the named instance does not
      // exist, returns `NOT_FOUND`.
      //
      // Immediately upon completion of this request:
      //
      //   * For resource types for which a decrease in the instance's allocation
      //     has been requested, billing is based on the newly-requested level.
      //
      // Until completion of the returned operation:
      //
      //   * Cancelling the operation sets its metadata's
      //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstanceMetadata.cancel_time],
      //     and begins restoring resources to their pre-request values. The
      //     operation is guaranteed to succeed at undoing all resource changes,
      //     after which point it terminates with a `CANCELLED` status.
      //   * All other attempts to modify the instance are rejected.
      //   * Reading the instance via the API continues to give the pre-request
      //     resource levels.
      //
      // Upon completion of the returned operation:
      //
      //   * Billing begins for all successfully-allocated resources (some types
      //     may have lower than the requested levels).
      //   * All newly-reserved resources are available for serving the instance's
      //     tables.
      //   * The instance's new resource levels are readable via the API.
      //
      // The returned [long-running operation][google.longrunning.Operation] will
      // have a name of the format `<instance_name>/operations/<operation_id>` and
      // can be used to track the instance modification.  The
      // [metadata][google.longrunning.Operation.metadata] field type is
      // [UpdateInstanceMetadata][google.spanner.admin.instance.v1.UpdateInstanceMetadata].
      // The [response][google.longrunning.Operation.response] field type is
      // [Instance][google.spanner.admin.instance.v1.Instance], if successful.
      //
      // Authorization requires `spanner.instances.update` permission on
      // the resource [name][google.spanner.admin.instance.v1.Instance.name].
      virtual void UpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an instance.
      //
      // Immediately upon completion of the request:
      //
      //   * Billing ceases for all of the instance's reserved resources.
      //
      // Soon afterward:
      //
      //   * The instance and *all of its databases* immediately and
      //     irrevocably disappear from the API. All data in the databases
      //     is permanently deleted.
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sets the access control policy on an instance resource. Replaces any
      // existing policy.
      //
      // Authorization requires `spanner.instances.setIamPolicy` on
      // [resource][google.iam.v1.SetIamPolicyRequest.resource].
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the access control policy for an instance resource. Returns an empty
      // policy if an instance exists but does not have a policy set.
      //
      // Authorization requires `spanner.instances.getIamPolicy` on
      // [resource][google.iam.v1.GetIamPolicyRequest.resource].
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns permissions that the caller has on the specified instance resource.
      //
      // Attempting this RPC on a non-existent Cloud Spanner instance resource will
      // result in a NOT_FOUND error if the user has `spanner.instances.list`
      // permission on the containing Google Cloud Project. Otherwise returns an
      // empty set of permissions.
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information about a particular instance partition.
      virtual void GetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* request, ::google::spanner::admin::instance::v1::InstancePartition* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* request, ::google::spanner::admin::instance::v1::InstancePartition* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an instance partition and begins preparing it to be used. The
      // returned [long-running operation][google.longrunning.Operation]
      // can be used to track the progress of preparing the new instance partition.
      // The instance partition name is assigned by the caller. If the named
      // instance partition already exists, `CreateInstancePartition` returns
      // `ALREADY_EXISTS`.
      //
      // Immediately upon completion of this request:
      //
      //   * The instance partition is readable via the API, with all requested
      //     attributes but no allocated resources. Its state is `CREATING`.
      //
      // Until completion of the returned operation:
      //
      //   * Cancelling the operation renders the instance partition immediately
      //     unreadable via the API.
      //   * The instance partition can be deleted.
      //   * All other attempts to modify the instance partition are rejected.
      //
      // Upon completion of the returned operation:
      //
      //   * Billing for all successfully-allocated resources begins (some types
      //     may have lower than the requested levels).
      //   * Databases can start using this instance partition.
      //   * The instance partition's allocated resource levels are readable via the
      //     API.
      //   * The instance partition's state becomes `READY`.
      //
      // The returned [long-running operation][google.longrunning.Operation] will
      // have a name of the format
      // `<instance_partition_name>/operations/<operation_id>` and can be used to
      // track creation of the instance partition.  The
      // [metadata][google.longrunning.Operation.metadata] field type is
      // [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata].
      // The [response][google.longrunning.Operation.response] field type is
      // [InstancePartition][google.spanner.admin.instance.v1.InstancePartition], if
      // successful.
      virtual void CreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an existing instance partition. Requires that the
      // instance partition is not used by any database or backup and is not the
      // default instance partition of an instance.
      //
      // Authorization requires `spanner.instancePartitions.delete` permission on
      // the resource
      // [name][google.spanner.admin.instance.v1.InstancePartition.name].
      virtual void DeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an instance partition, and begins allocating or releasing resources
      // as requested. The returned [long-running
      // operation][google.longrunning.Operation] can be used to track the
      // progress of updating the instance partition. If the named instance
      // partition does not exist, returns `NOT_FOUND`.
      //
      // Immediately upon completion of this request:
      //
      //   * For resource types for which a decrease in the instance partition's
      //   allocation has been requested, billing is based on the newly-requested
      //   level.
      //
      // Until completion of the returned operation:
      //
      //   * Cancelling the operation sets its metadata's
      //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstancePartitionMetadata.cancel_time],
      //     and begins restoring resources to their pre-request values. The
      //     operation is guaranteed to succeed at undoing all resource changes,
      //     after which point it terminates with a `CANCELLED` status.
      //   * All other attempts to modify the instance partition are rejected.
      //   * Reading the instance partition via the API continues to give the
      //     pre-request resource levels.
      //
      // Upon completion of the returned operation:
      //
      //   * Billing begins for all successfully-allocated resources (some types
      //     may have lower than the requested levels).
      //   * All newly-reserved resources are available for serving the instance
      //     partition's tables.
      //   * The instance partition's new resource levels are readable via the API.
      //
      // The returned [long-running operation][google.longrunning.Operation] will
      // have a name of the format
      // `<instance_partition_name>/operations/<operation_id>` and can be used to
      // track the instance partition modification. The
      // [metadata][google.longrunning.Operation.metadata] field type is
      // [UpdateInstancePartitionMetadata][google.spanner.admin.instance.v1.UpdateInstancePartitionMetadata].
      // The [response][google.longrunning.Operation.response] field type is
      // [InstancePartition][google.spanner.admin.instance.v1.InstancePartition], if
      // successful.
      //
      // Authorization requires `spanner.instancePartitions.update` permission on
      // the resource
      // [name][google.spanner.admin.instance.v1.InstancePartition.name].
      virtual void UpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists instance partition [long-running
      // operations][google.longrunning.Operation] in the given instance.
      // An instance partition operation has a name of the form
      // `projects/<project>/instances/<instance>/instancePartitions/<instance_partition>/operations/<operation>`.
      // The long-running operation
      // [metadata][google.longrunning.Operation.metadata] field type
      // `metadata.type_url` describes the type of the metadata. Operations returned
      // include those that have completed/failed/canceled within the last 7 days,
      // and pending operations. Operations returned are ordered by
      // `operation.metadata.value.start_time` in descending order starting from the
      // most recently started operation.
      //
      // Authorization requires `spanner.instancePartitionOperations.list`
      // permission on the resource
      // [parent][google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest.parent].
      virtual void ListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Moves an instance to the target instance configuration. You can use the
      // returned [long-running operation][google.longrunning.Operation] to track
      // the progress of moving the instance.
      //
      // `MoveInstance` returns `FAILED_PRECONDITION` if the instance meets any of
      // the following criteria:
      //
      //   * Is undergoing a move to a different instance configuration
      //   * Has backups
      //   * Has an ongoing update
      //   * Contains any CMEK-enabled databases
      //   * Is a free trial instance
      //
      // While the operation is pending:
      //
      //   * All other attempts to modify the instance, including changes to its
      //     compute capacity, are rejected.
      //   * The following database and backup admin operations are rejected:
      //
      //     * `DatabaseAdmin.CreateDatabase`
      //     * `DatabaseAdmin.UpdateDatabaseDdl` (disabled if default_leader is
      //        specified in the request.)
      //     * `DatabaseAdmin.RestoreDatabase`
      //     * `DatabaseAdmin.CreateBackup`
      //     * `DatabaseAdmin.CopyBackup`
      //
      //   * Both the source and target instance configurations are subject to
      //     hourly compute and storage charges.
      //   * The instance might experience higher read-write latencies and a higher
      //     transaction abort rate. However, moving an instance doesn't cause any
      //     downtime.
      //
      // The returned [long-running operation][google.longrunning.Operation] has
      // a name of the format
      // `<instance_name>/operations/<operation_id>` and can be used to track
      // the move instance operation. The
      // [metadata][google.longrunning.Operation.metadata] field type is
      // [MoveInstanceMetadata][google.spanner.admin.instance.v1.MoveInstanceMetadata].
      // The [response][google.longrunning.Operation.response] field type is
      // [Instance][google.spanner.admin.instance.v1.Instance],
      // if successful.
      // Cancelling the operation sets its metadata's
      // [cancel_time][google.spanner.admin.instance.v1.MoveInstanceMetadata.cancel_time].
      // Cancellation is not immediate because it involves moving any data
      // previously moved to the target instance configuration back to the original
      // instance configuration. You can use this operation to track the progress of
      // the cancellation. Upon successful completion of the cancellation, the
      // operation terminates with `CANCELLED` status.
      //
      // If not cancelled, upon completion of the returned operation:
      //
      //   * The instance successfully moves to the target instance
      //     configuration.
      //   * You are billed for compute and storage in target instance
      //   configuration.
      //
      // Authorization requires the `spanner.instances.update` permission on
      // the resource [instance][google.spanner.admin.instance.v1.Instance].
      //
      // For more details, see
      // [Move an instance](https://cloud.google.com/spanner/docs/move-instance).
      virtual void MoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* AsyncListInstanceConfigsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* PrepareAsyncListInstanceConfigsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstanceConfig>* AsyncGetInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstanceConfig>* PrepareAsyncGetInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* AsyncListInstanceConfigOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* PrepareAsyncListInstanceConfigOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* AsyncListInstancePartitionsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* PrepareAsyncListInstancePartitionsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstancePartition>* AsyncGetInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::InstancePartition>* PrepareAsyncGetInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* AsyncListInstancePartitionOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* PrepareAsyncListInstancePartitionOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncMoveInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncMoveInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>> AsyncListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>>(AsyncListInstanceConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>> PrepareAsyncListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>>(PrepareAsyncListInstanceConfigsRaw(context, request, cq));
    }
    ::grpc::Status GetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::google::spanner::admin::instance::v1::InstanceConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstanceConfig>> AsyncGetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstanceConfig>>(AsyncGetInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstanceConfig>> PrepareAsyncGetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstanceConfig>>(PrepareAsyncGetInstanceConfigRaw(context, request, cq));
    }
    ::grpc::Status CreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    ::grpc::Status DeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteInstanceConfigRaw(context, request, cq));
    }
    ::grpc::Status ListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>> AsyncListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>>(AsyncListInstanceConfigOperationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>> PrepareAsyncListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>>(PrepareAsyncListInstanceConfigOperationsRaw(context, request, cq));
    }
    ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    ::grpc::Status ListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>> AsyncListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>>(AsyncListInstancePartitionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>> PrepareAsyncListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>>(PrepareAsyncListInstancePartitionsRaw(context, request, cq));
    }
    ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::google::spanner::admin::instance::v1::Instance* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    ::grpc::Status UpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceRaw(context, request, cq));
    }
    ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    ::grpc::Status GetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::google::spanner::admin::instance::v1::InstancePartition* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstancePartition>> AsyncGetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstancePartition>>(AsyncGetInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstancePartition>> PrepareAsyncGetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstancePartition>>(PrepareAsyncGetInstancePartitionRaw(context, request, cq));
    }
    ::grpc::Status CreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInstancePartitionRaw(context, request, cq));
    }
    ::grpc::Status DeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteInstancePartitionRaw(context, request, cq));
    }
    ::grpc::Status UpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateInstancePartitionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstancePartitionRaw(context, request, cq));
    }
    ::grpc::Status ListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>> AsyncListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>>(AsyncListInstancePartitionOperationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>> PrepareAsyncListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>>(PrepareAsyncListInstancePartitionOperationsRaw(context, request, cq));
    }
    ::grpc::Status MoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncMoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncMoveInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncMoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncMoveInstanceRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstanceConfigs(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* request, ::google::spanner::admin::instance::v1::InstanceConfig* response, std::function<void(::grpc::Status)>) override;
      void GetInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* request, ::google::spanner::admin::instance::v1::InstanceConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteInstanceConfig(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstanceConfigOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest* request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstances(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest* request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstancePartitions(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest* request, ::google::spanner::admin::instance::v1::Instance* response, std::function<void(::grpc::Status)>) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest* request, ::google::spanner::admin::instance::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* request, ::google::spanner::admin::instance::v1::InstancePartition* response, std::function<void(::grpc::Status)>) override;
      void GetInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* request, ::google::spanner::admin::instance::v1::InstancePartition* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateInstancePartition(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstancePartitionOperations(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void MoveInstance(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* AsyncListInstanceConfigsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* PrepareAsyncListInstanceConfigsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstanceConfig>* AsyncGetInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstanceConfig>* PrepareAsyncGetInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteInstanceConfigRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* AsyncListInstanceConfigOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* PrepareAsyncListInstanceConfigOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* AsyncListInstancePartitionsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* PrepareAsyncListInstancePartitionsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstancePartition>* AsyncGetInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::InstancePartition>* PrepareAsyncGetInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateInstancePartitionRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* AsyncListInstancePartitionOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* PrepareAsyncListInstancePartitionOperationsRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncMoveInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncMoveInstanceRaw(::grpc::ClientContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstanceConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInstanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInstanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInstanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstanceConfigOperations_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstances_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstancePartitions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstancePartition_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInstancePartition_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInstancePartition_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInstancePartition_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstancePartitionOperations_;
    const ::grpc::internal::RpcMethod rpcmethod_MoveInstance_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the supported instance configurations for a given project.
    virtual ::grpc::Status ListInstanceConfigs(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response);
    // Gets information about a particular instance configuration.
    virtual ::grpc::Status GetInstanceConfig(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* request, ::google::spanner::admin::instance::v1::InstanceConfig* response);
    // Creates an instance configuration and begins preparing it to be used. The
    // returned [long-running operation][google.longrunning.Operation]
    // can be used to track the progress of preparing the new
    // instance configuration. The instance configuration name is assigned by the
    // caller. If the named instance configuration already exists,
    // `CreateInstanceConfig` returns `ALREADY_EXISTS`.
    //
    // Immediately after the request returns:
    //
    //   * The instance configuration is readable via the API, with all requested
    //     attributes. The instance configuration's
    //     [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //     field is set to true. Its state is `CREATING`.
    //
    // While the operation is pending:
    //
    //   * Cancelling the operation renders the instance configuration immediately
    //     unreadable via the API.
    //   * Except for deleting the creating resource, all other attempts to modify
    //     the instance configuration are rejected.
    //
    // Upon completion of the returned operation:
    //
    //   * Instances can be created using the instance configuration.
    //   * The instance configuration's
    //   [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //   field becomes false. Its state becomes `READY`.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_config_name>/operations/<operation_id>` and can be used to track
    // creation of the instance configuration. The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [CreateInstanceConfigMetadata][google.spanner.admin.instance.v1.CreateInstanceConfigMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstanceConfig][google.spanner.admin.instance.v1.InstanceConfig], if
    // successful.
    //
    // Authorization requires `spanner.instanceConfigs.create` permission on
    // the resource
    // [parent][google.spanner.admin.instance.v1.CreateInstanceConfigRequest.parent].
    virtual ::grpc::Status CreateInstanceConfig(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* request, ::google::longrunning::Operation* response);
    // Updates an instance configuration. The returned
    // [long-running operation][google.longrunning.Operation] can be used to track
    // the progress of updating the instance. If the named instance configuration
    // does not exist, returns `NOT_FOUND`.
    //
    // Only user-managed configurations can be updated.
    //
    // Immediately after the request returns:
    //
    //   * The instance configuration's
    //     [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //     field is set to true.
    //
    // While the operation is pending:
    //
    //   * Cancelling the operation sets its metadata's
    //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstanceConfigMetadata.cancel_time].
    //     The operation is guaranteed to succeed at undoing all changes, after
    //     which point it terminates with a `CANCELLED` status.
    //   * All other attempts to modify the instance configuration are rejected.
    //   * Reading the instance configuration via the API continues to give the
    //     pre-request values.
    //
    // Upon completion of the returned operation:
    //
    //   * Creating instances using the instance configuration uses the new
    //     values.
    //   * The new values of the instance configuration are readable via the API.
    //   * The instance configuration's
    //   [reconciling][google.spanner.admin.instance.v1.InstanceConfig.reconciling]
    //   field becomes false.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_config_name>/operations/<operation_id>` and can be used to track
    // the instance configuration modification.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [UpdateInstanceConfigMetadata][google.spanner.admin.instance.v1.UpdateInstanceConfigMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstanceConfig][google.spanner.admin.instance.v1.InstanceConfig], if
    // successful.
    //
    // Authorization requires `spanner.instanceConfigs.update` permission on
    // the resource [name][google.spanner.admin.instance.v1.InstanceConfig.name].
    virtual ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response);
    // Deletes the instance configuration. Deletion is only allowed when no
    // instances are using the configuration. If any instances are using
    // the configuration, returns `FAILED_PRECONDITION`.
    //
    // Only user-managed configurations can be deleted.
    //
    // Authorization requires `spanner.instanceConfigs.delete` permission on
    // the resource [name][google.spanner.admin.instance.v1.InstanceConfig.name].
    virtual ::grpc::Status DeleteInstanceConfig(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* request, ::google::protobuf::Empty* response);
    // Lists the user-managed instance configuration [long-running
    // operations][google.longrunning.Operation] in the given project. An instance
    // configuration operation has a name of the form
    // `projects/<project>/instanceConfigs/<instance_config>/operations/<operation>`.
    // The long-running operation
    // [metadata][google.longrunning.Operation.metadata] field type
    // `metadata.type_url` describes the type of the metadata. Operations returned
    // include those that have completed/failed/canceled within the last 7 days,
    // and pending operations. Operations returned are ordered by
    // `operation.metadata.value.start_time` in descending order starting
    // from the most recently started operation.
    virtual ::grpc::Status ListInstanceConfigOperations(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response);
    // Lists all instances in the given project.
    virtual ::grpc::Status ListInstances(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest* request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response);
    // Lists all instance partitions for the given instance.
    virtual ::grpc::Status ListInstancePartitions(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response);
    // Gets information about a particular instance.
    virtual ::grpc::Status GetInstance(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest* request, ::google::spanner::admin::instance::v1::Instance* response);
    // Creates an instance and begins preparing it to begin serving. The
    // returned [long-running operation][google.longrunning.Operation]
    // can be used to track the progress of preparing the new
    // instance. The instance name is assigned by the caller. If the
    // named instance already exists, `CreateInstance` returns
    // `ALREADY_EXISTS`.
    //
    // Immediately upon completion of this request:
    //
    //   * The instance is readable via the API, with all requested attributes
    //     but no allocated resources. Its state is `CREATING`.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation renders the instance immediately unreadable
    //     via the API.
    //   * The instance can be deleted.
    //   * All other attempts to modify the instance are rejected.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing for all successfully-allocated resources begins (some types
    //     may have lower than the requested levels).
    //   * Databases can be created in the instance.
    //   * The instance's allocated resource levels are readable via the API.
    //   * The instance's state becomes `READY`.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format `<instance_name>/operations/<operation_id>` and
    // can be used to track creation of the instance.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [CreateInstanceMetadata][google.spanner.admin.instance.v1.CreateInstanceMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [Instance][google.spanner.admin.instance.v1.Instance], if successful.
    virtual ::grpc::Status CreateInstance(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response);
    // Updates an instance, and begins allocating or releasing resources
    // as requested. The returned [long-running
    // operation][google.longrunning.Operation] can be used to track the
    // progress of updating the instance. If the named instance does not
    // exist, returns `NOT_FOUND`.
    //
    // Immediately upon completion of this request:
    //
    //   * For resource types for which a decrease in the instance's allocation
    //     has been requested, billing is based on the newly-requested level.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation sets its metadata's
    //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstanceMetadata.cancel_time],
    //     and begins restoring resources to their pre-request values. The
    //     operation is guaranteed to succeed at undoing all resource changes,
    //     after which point it terminates with a `CANCELLED` status.
    //   * All other attempts to modify the instance are rejected.
    //   * Reading the instance via the API continues to give the pre-request
    //     resource levels.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing begins for all successfully-allocated resources (some types
    //     may have lower than the requested levels).
    //   * All newly-reserved resources are available for serving the instance's
    //     tables.
    //   * The instance's new resource levels are readable via the API.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format `<instance_name>/operations/<operation_id>` and
    // can be used to track the instance modification.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [UpdateInstanceMetadata][google.spanner.admin.instance.v1.UpdateInstanceMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [Instance][google.spanner.admin.instance.v1.Instance], if successful.
    //
    // Authorization requires `spanner.instances.update` permission on
    // the resource [name][google.spanner.admin.instance.v1.Instance.name].
    virtual ::grpc::Status UpdateInstance(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response);
    // Deletes an instance.
    //
    // Immediately upon completion of the request:
    //
    //   * Billing ceases for all of the instance's reserved resources.
    //
    // Soon afterward:
    //
    //   * The instance and *all of its databases* immediately and
    //     irrevocably disappear from the API. All data in the databases
    //     is permanently deleted.
    virtual ::grpc::Status DeleteInstance(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* request, ::google::protobuf::Empty* response);
    // Sets the access control policy on an instance resource. Replaces any
    // existing policy.
    //
    // Authorization requires `spanner.instances.setIamPolicy` on
    // [resource][google.iam.v1.SetIamPolicyRequest.resource].
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Gets the access control policy for an instance resource. Returns an empty
    // policy if an instance exists but does not have a policy set.
    //
    // Authorization requires `spanner.instances.getIamPolicy` on
    // [resource][google.iam.v1.GetIamPolicyRequest.resource].
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Returns permissions that the caller has on the specified instance resource.
    //
    // Attempting this RPC on a non-existent Cloud Spanner instance resource will
    // result in a NOT_FOUND error if the user has `spanner.instances.list`
    // permission on the containing Google Cloud Project. Otherwise returns an
    // empty set of permissions.
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
    // Gets information about a particular instance partition.
    virtual ::grpc::Status GetInstancePartition(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* request, ::google::spanner::admin::instance::v1::InstancePartition* response);
    // Creates an instance partition and begins preparing it to be used. The
    // returned [long-running operation][google.longrunning.Operation]
    // can be used to track the progress of preparing the new instance partition.
    // The instance partition name is assigned by the caller. If the named
    // instance partition already exists, `CreateInstancePartition` returns
    // `ALREADY_EXISTS`.
    //
    // Immediately upon completion of this request:
    //
    //   * The instance partition is readable via the API, with all requested
    //     attributes but no allocated resources. Its state is `CREATING`.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation renders the instance partition immediately
    //     unreadable via the API.
    //   * The instance partition can be deleted.
    //   * All other attempts to modify the instance partition are rejected.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing for all successfully-allocated resources begins (some types
    //     may have lower than the requested levels).
    //   * Databases can start using this instance partition.
    //   * The instance partition's allocated resource levels are readable via the
    //     API.
    //   * The instance partition's state becomes `READY`.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_partition_name>/operations/<operation_id>` and can be used to
    // track creation of the instance partition.  The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [CreateInstancePartitionMetadata][google.spanner.admin.instance.v1.CreateInstancePartitionMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstancePartition][google.spanner.admin.instance.v1.InstancePartition], if
    // successful.
    virtual ::grpc::Status CreateInstancePartition(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* request, ::google::longrunning::Operation* response);
    // Deletes an existing instance partition. Requires that the
    // instance partition is not used by any database or backup and is not the
    // default instance partition of an instance.
    //
    // Authorization requires `spanner.instancePartitions.delete` permission on
    // the resource
    // [name][google.spanner.admin.instance.v1.InstancePartition.name].
    virtual ::grpc::Status DeleteInstancePartition(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* request, ::google::protobuf::Empty* response);
    // Updates an instance partition, and begins allocating or releasing resources
    // as requested. The returned [long-running
    // operation][google.longrunning.Operation] can be used to track the
    // progress of updating the instance partition. If the named instance
    // partition does not exist, returns `NOT_FOUND`.
    //
    // Immediately upon completion of this request:
    //
    //   * For resource types for which a decrease in the instance partition's
    //   allocation has been requested, billing is based on the newly-requested
    //   level.
    //
    // Until completion of the returned operation:
    //
    //   * Cancelling the operation sets its metadata's
    //     [cancel_time][google.spanner.admin.instance.v1.UpdateInstancePartitionMetadata.cancel_time],
    //     and begins restoring resources to their pre-request values. The
    //     operation is guaranteed to succeed at undoing all resource changes,
    //     after which point it terminates with a `CANCELLED` status.
    //   * All other attempts to modify the instance partition are rejected.
    //   * Reading the instance partition via the API continues to give the
    //     pre-request resource levels.
    //
    // Upon completion of the returned operation:
    //
    //   * Billing begins for all successfully-allocated resources (some types
    //     may have lower than the requested levels).
    //   * All newly-reserved resources are available for serving the instance
    //     partition's tables.
    //   * The instance partition's new resource levels are readable via the API.
    //
    // The returned [long-running operation][google.longrunning.Operation] will
    // have a name of the format
    // `<instance_partition_name>/operations/<operation_id>` and can be used to
    // track the instance partition modification. The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [UpdateInstancePartitionMetadata][google.spanner.admin.instance.v1.UpdateInstancePartitionMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [InstancePartition][google.spanner.admin.instance.v1.InstancePartition], if
    // successful.
    //
    // Authorization requires `spanner.instancePartitions.update` permission on
    // the resource
    // [name][google.spanner.admin.instance.v1.InstancePartition.name].
    virtual ::grpc::Status UpdateInstancePartition(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* request, ::google::longrunning::Operation* response);
    // Lists instance partition [long-running
    // operations][google.longrunning.Operation] in the given instance.
    // An instance partition operation has a name of the form
    // `projects/<project>/instances/<instance>/instancePartitions/<instance_partition>/operations/<operation>`.
    // The long-running operation
    // [metadata][google.longrunning.Operation.metadata] field type
    // `metadata.type_url` describes the type of the metadata. Operations returned
    // include those that have completed/failed/canceled within the last 7 days,
    // and pending operations. Operations returned are ordered by
    // `operation.metadata.value.start_time` in descending order starting from the
    // most recently started operation.
    //
    // Authorization requires `spanner.instancePartitionOperations.list`
    // permission on the resource
    // [parent][google.spanner.admin.instance.v1.ListInstancePartitionOperationsRequest.parent].
    virtual ::grpc::Status ListInstancePartitionOperations(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response);
    // Moves an instance to the target instance configuration. You can use the
    // returned [long-running operation][google.longrunning.Operation] to track
    // the progress of moving the instance.
    //
    // `MoveInstance` returns `FAILED_PRECONDITION` if the instance meets any of
    // the following criteria:
    //
    //   * Is undergoing a move to a different instance configuration
    //   * Has backups
    //   * Has an ongoing update
    //   * Contains any CMEK-enabled databases
    //   * Is a free trial instance
    //
    // While the operation is pending:
    //
    //   * All other attempts to modify the instance, including changes to its
    //     compute capacity, are rejected.
    //   * The following database and backup admin operations are rejected:
    //
    //     * `DatabaseAdmin.CreateDatabase`
    //     * `DatabaseAdmin.UpdateDatabaseDdl` (disabled if default_leader is
    //        specified in the request.)
    //     * `DatabaseAdmin.RestoreDatabase`
    //     * `DatabaseAdmin.CreateBackup`
    //     * `DatabaseAdmin.CopyBackup`
    //
    //   * Both the source and target instance configurations are subject to
    //     hourly compute and storage charges.
    //   * The instance might experience higher read-write latencies and a higher
    //     transaction abort rate. However, moving an instance doesn't cause any
    //     downtime.
    //
    // The returned [long-running operation][google.longrunning.Operation] has
    // a name of the format
    // `<instance_name>/operations/<operation_id>` and can be used to track
    // the move instance operation. The
    // [metadata][google.longrunning.Operation.metadata] field type is
    // [MoveInstanceMetadata][google.spanner.admin.instance.v1.MoveInstanceMetadata].
    // The [response][google.longrunning.Operation.response] field type is
    // [Instance][google.spanner.admin.instance.v1.Instance],
    // if successful.
    // Cancelling the operation sets its metadata's
    // [cancel_time][google.spanner.admin.instance.v1.MoveInstanceMetadata.cancel_time].
    // Cancellation is not immediate because it involves moving any data
    // previously moved to the target instance configuration back to the original
    // instance configuration. You can use this operation to track the progress of
    // the cancellation. Upon successful completion of the cancellation, the
    // operation terminates with `CANCELLED` status.
    //
    // If not cancelled, upon completion of the returned operation:
    //
    //   * The instance successfully moves to the target instance
    //     configuration.
    //   * You are billed for compute and storage in target instance
    //   configuration.
    //
    // Authorization requires the `spanner.instances.update` permission on
    // the resource [instance][google.spanner.admin.instance.v1.Instance].
    //
    // For more details, see
    // [Move an instance](https://cloud.google.com/spanner/docs/move-instance).
    virtual ::grpc::Status MoveInstance(::grpc::ServerContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstanceConfigs() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListInstanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigs(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstanceConfigs(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstanceConfig() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* /*request*/, ::google::spanner::admin::instance::v1::InstanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstanceConfig(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::InstanceConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInstanceConfig() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstanceConfig(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstanceConfig(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInstanceConfig() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstanceConfig(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstanceConfigOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstanceConfigOperations() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListInstanceConfigOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstanceConfigOperations(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstances() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancesRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::ListInstancesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::ListInstancesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstancePartitions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstancePartitions() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListInstancePartitions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitions(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstancePartitions(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstance() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceRequest* /*request*/, ::google::spanner::admin::instance::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::GetInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::Instance>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInstance() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::CreateInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstance(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::UpdateInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::DeleteInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstancePartition() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_GetInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* /*request*/, ::google::spanner::admin::instance::v1::InstancePartition* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstancePartition(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::InstancePartition>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInstancePartition() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_CreateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstancePartition(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInstancePartition() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_DeleteInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstancePartition(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInstancePartition() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_UpdateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstancePartition(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstancePartitionOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstancePartitionOperations() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_ListInstancePartitionOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitionOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstancePartitionOperations(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MoveInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MoveInstance() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_MoveInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveInstance(::grpc::ServerContext* context, ::google::spanner::admin::instance::v1::MoveInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListInstanceConfigs<WithAsyncMethod_GetInstanceConfig<WithAsyncMethod_CreateInstanceConfig<WithAsyncMethod_UpdateInstanceConfig<WithAsyncMethod_DeleteInstanceConfig<WithAsyncMethod_ListInstanceConfigOperations<WithAsyncMethod_ListInstances<WithAsyncMethod_ListInstancePartitions<WithAsyncMethod_GetInstance<WithAsyncMethod_CreateInstance<WithAsyncMethod_UpdateInstance<WithAsyncMethod_DeleteInstance<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_TestIamPermissions<WithAsyncMethod_GetInstancePartition<WithAsyncMethod_CreateInstancePartition<WithAsyncMethod_DeleteInstancePartition<WithAsyncMethod_UpdateInstancePartition<WithAsyncMethod_ListInstancePartitionOperations<WithAsyncMethod_MoveInstance<Service > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListInstanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstanceConfigs() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* response) { return this->ListInstanceConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstanceConfigs(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigs(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstanceConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstanceConfig() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::GetInstanceConfigRequest, ::google::spanner::admin::instance::v1::InstanceConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* request, ::google::spanner::admin::instance::v1::InstanceConfig* response) { return this->GetInstanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstanceConfig(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::GetInstanceConfigRequest, ::google::spanner::admin::instance::v1::InstanceConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::GetInstanceConfigRequest, ::google::spanner::admin::instance::v1::InstanceConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* /*request*/, ::google::spanner::admin::instance::v1::InstanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* /*request*/, ::google::spanner::admin::instance::v1::InstanceConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInstanceConfig() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* request, ::google::longrunning::Operation* response) { return this->CreateInstanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInstanceConfig(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response) { return this->UpdateInstanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInstanceConfig(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInstanceConfig() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* request, ::google::protobuf::Empty* response) { return this->DeleteInstanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInstanceConfig(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInstanceConfigOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstanceConfigOperations() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* response) { return this->ListInstanceConfigOperations(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstanceConfigOperations(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstanceConfigOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstanceConfigOperations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstancesRequest, ::google::spanner::admin::instance::v1::ListInstancesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::ListInstancesRequest* request, ::google::spanner::admin::instance::v1::ListInstancesResponse* response) { return this->ListInstances(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstances(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::ListInstancesRequest, ::google::spanner::admin::instance::v1::ListInstancesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstancesRequest, ::google::spanner::admin::instance::v1::ListInstancesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancesRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancesRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInstancePartitions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstancePartitions() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* response) { return this->ListInstancePartitions(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstancePartitions(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstancePartitions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitions(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstancePartitions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::GetInstanceRequest, ::google::spanner::admin::instance::v1::Instance>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::GetInstanceRequest* request, ::google::spanner::admin::instance::v1::Instance* response) { return this->GetInstance(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstance(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::GetInstanceRequest, ::google::spanner::admin::instance::v1::Instance>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::GetInstanceRequest, ::google::spanner::admin::instance::v1::Instance>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceRequest* /*request*/, ::google::spanner::admin::instance::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceRequest* /*request*/, ::google::spanner::admin::instance::v1::Instance* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response) { return this->CreateInstance(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInstance(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::CreateInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::CreateInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::UpdateInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response) { return this->UpdateInstance(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInstance(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::UpdateInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::UpdateInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::DeleteInstanceRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* request, ::google::protobuf::Empty* response) { return this->DeleteInstance(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInstance(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::DeleteInstanceRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::DeleteInstanceRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstancePartition() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::GetInstancePartitionRequest, ::google::spanner::admin::instance::v1::InstancePartition>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* request, ::google::spanner::admin::instance::v1::InstancePartition* response) { return this->GetInstancePartition(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstancePartition(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::GetInstancePartitionRequest, ::google::spanner::admin::instance::v1::InstancePartition>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::GetInstancePartitionRequest, ::google::spanner::admin::instance::v1::InstancePartition>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* /*request*/, ::google::spanner::admin::instance::v1::InstancePartition* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* /*request*/, ::google::spanner::admin::instance::v1::InstancePartition* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInstancePartition() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* request, ::google::longrunning::Operation* response) { return this->CreateInstancePartition(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInstancePartition(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInstancePartition() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* request, ::google::protobuf::Empty* response) { return this->DeleteInstancePartition(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInstancePartition(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInstancePartition() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* request, ::google::longrunning::Operation* response) { return this->UpdateInstancePartition(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInstancePartition(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInstancePartitionOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstancePartitionOperations() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* request, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* response) { return this->ListInstancePartitionOperations(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstancePartitionOperations(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstancePartitionOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitionOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstancePartitionOperations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MoveInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MoveInstance() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::MoveInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* request, ::google::longrunning::Operation* response) { return this->MoveInstance(context, request, response); }));}
    void SetMessageAllocatorFor_MoveInstance(
        ::grpc::MessageAllocator< ::google::spanner::admin::instance::v1::MoveInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::spanner::admin::instance::v1::MoveInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MoveInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListInstanceConfigs<WithCallbackMethod_GetInstanceConfig<WithCallbackMethod_CreateInstanceConfig<WithCallbackMethod_UpdateInstanceConfig<WithCallbackMethod_DeleteInstanceConfig<WithCallbackMethod_ListInstanceConfigOperations<WithCallbackMethod_ListInstances<WithCallbackMethod_ListInstancePartitions<WithCallbackMethod_GetInstance<WithCallbackMethod_CreateInstance<WithCallbackMethod_UpdateInstance<WithCallbackMethod_DeleteInstance<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_TestIamPermissions<WithCallbackMethod_GetInstancePartition<WithCallbackMethod_CreateInstancePartition<WithCallbackMethod_DeleteInstancePartition<WithCallbackMethod_UpdateInstancePartition<WithCallbackMethod_ListInstancePartitionOperations<WithCallbackMethod_MoveInstance<Service > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListInstanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstanceConfigs() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListInstanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigs(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstanceConfig() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* /*request*/, ::google::spanner::admin::instance::v1::InstanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInstanceConfig() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInstanceConfig() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInstanceConfigOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstanceConfigOperations() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListInstanceConfigOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstances() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancesRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInstancePartitions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstancePartitions() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListInstancePartitions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitions(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstance() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceRequest* /*request*/, ::google::spanner::admin::instance::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInstance() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstancePartition() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_GetInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* /*request*/, ::google::spanner::admin::instance::v1::InstancePartition* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInstancePartition() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_CreateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInstancePartition() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_DeleteInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInstancePartition() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_UpdateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInstancePartitionOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstancePartitionOperations() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_ListInstancePartitionOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitionOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MoveInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MoveInstance() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_MoveInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstanceConfigs() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListInstanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigs(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstanceConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstanceConfig() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* /*request*/, ::google::spanner::admin::instance::v1::InstanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInstanceConfig() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInstanceConfig() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstanceConfigOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstanceConfigOperations() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListInstanceConfigOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstanceConfigOperations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstances() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancesRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstancePartitions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstancePartitions() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListInstancePartitions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitions(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstancePartitions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstance() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceRequest* /*request*/, ::google::spanner::admin::instance::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstancePartition() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_GetInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* /*request*/, ::google::spanner::admin::instance::v1::InstancePartition* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstancePartition(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInstancePartition() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_CreateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstancePartition(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInstancePartition() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_DeleteInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstancePartition(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInstancePartition() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_UpdateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstancePartition(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstancePartitionOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstancePartitionOperations() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_ListInstancePartitionOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitionOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstancePartitionOperations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MoveInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MoveInstance() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_MoveInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstanceConfigs() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstanceConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigs(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstanceConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* /*request*/, ::google::spanner::admin::instance::v1::InstanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInstanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInstanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInstanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInstanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInstanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstanceConfigOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstanceConfigOperations() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstanceConfigOperations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstanceConfigOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstanceConfigOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstanceConfigOperations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstances(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancesRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstancePartitions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstancePartitions() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstancePartitions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstancePartitions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitions(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstancePartitions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceRequest* /*request*/, ::google::spanner::admin::instance::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstancePartition() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstancePartition(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* /*request*/, ::google::spanner::admin::instance::v1::InstancePartition* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInstancePartition() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInstancePartition(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInstancePartition() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInstancePartition(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInstancePartition() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInstancePartition(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstancePartition(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstancePartitionOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstancePartitionOperations() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstancePartitionOperations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstancePartitionOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstancePartitionOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstancePartitionOperations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MoveInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MoveInstance() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MoveInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_MoveInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstanceConfigs() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* streamer) {
                       return this->StreamedListInstanceConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstanceConfigs(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstanceConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::ListInstanceConfigsRequest,::google::spanner::admin::instance::v1::ListInstanceConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstanceConfig() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::GetInstanceConfigRequest, ::google::spanner::admin::instance::v1::InstanceConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::GetInstanceConfigRequest, ::google::spanner::admin::instance::v1::InstanceConfig>* streamer) {
                       return this->StreamedGetInstanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceConfigRequest* /*request*/, ::google::spanner::admin::instance::v1::InstanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::GetInstanceConfigRequest,::google::spanner::admin::instance::v1::InstanceConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInstanceConfig() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInstanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInstanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::CreateInstanceConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateInstanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInstanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::UpdateInstanceConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInstanceConfig() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteInstanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInstanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::DeleteInstanceConfigRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstanceConfigOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstanceConfigOperations() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* streamer) {
                       return this->StreamedListInstanceConfigOperations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstanceConfigOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstanceConfigOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstanceConfigOperations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::ListInstanceConfigOperationsRequest,::google::spanner::admin::instance::v1::ListInstanceConfigOperationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstances() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::ListInstancesRequest, ::google::spanner::admin::instance::v1::ListInstancesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::ListInstancesRequest, ::google::spanner::admin::instance::v1::ListInstancesResponse>* streamer) {
                       return this->StreamedListInstances(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancesRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstances(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::ListInstancesRequest,::google::spanner::admin::instance::v1::ListInstancesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstancePartitions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstancePartitions() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* streamer) {
                       return this->StreamedListInstancePartitions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstancePartitions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstancePartitions(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstancePartitions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::ListInstancePartitionsRequest,::google::spanner::admin::instance::v1::ListInstancePartitionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstance() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::GetInstanceRequest, ::google::spanner::admin::instance::v1::Instance>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::GetInstanceRequest, ::google::spanner::admin::instance::v1::Instance>* streamer) {
                       return this->StreamedGetInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstanceRequest* /*request*/, ::google::spanner::admin::instance::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::GetInstanceRequest,::google::spanner::admin::instance::v1::Instance>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInstance() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::CreateInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::CreateInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::UpdateInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::UpdateInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::UpdateInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::DeleteInstanceRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::DeleteInstanceRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstanceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::DeleteInstanceRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstancePartition() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::GetInstancePartitionRequest, ::google::spanner::admin::instance::v1::InstancePartition>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::GetInstancePartitionRequest, ::google::spanner::admin::instance::v1::InstancePartition>* streamer) {
                       return this->StreamedGetInstancePartition(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::GetInstancePartitionRequest* /*request*/, ::google::spanner::admin::instance::v1::InstancePartition* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstancePartition(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::GetInstancePartitionRequest,::google::spanner::admin::instance::v1::InstancePartition>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInstancePartition() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInstancePartition(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInstancePartition(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::CreateInstancePartitionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInstancePartition() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteInstancePartition(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInstancePartition(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::DeleteInstancePartitionRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInstancePartition : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInstancePartition() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateInstancePartition(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInstancePartition() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInstancePartition(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInstancePartition(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::UpdateInstancePartitionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstancePartitionOperations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstancePartitionOperations() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* streamer) {
                       return this->StreamedListInstancePartitionOperations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstancePartitionOperations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstancePartitionOperations(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest* /*request*/, ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstancePartitionOperations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::ListInstancePartitionOperationsRequest,::google::spanner::admin::instance::v1::ListInstancePartitionOperationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MoveInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MoveInstance() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::spanner::admin::instance::v1::MoveInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::spanner::admin::instance::v1::MoveInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedMoveInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MoveInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MoveInstance(::grpc::ServerContext* /*context*/, const ::google::spanner::admin::instance::v1::MoveInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMoveInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::spanner::admin::instance::v1::MoveInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListInstanceConfigs<WithStreamedUnaryMethod_GetInstanceConfig<WithStreamedUnaryMethod_CreateInstanceConfig<WithStreamedUnaryMethod_UpdateInstanceConfig<WithStreamedUnaryMethod_DeleteInstanceConfig<WithStreamedUnaryMethod_ListInstanceConfigOperations<WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_ListInstancePartitions<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_UpdateInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_GetInstancePartition<WithStreamedUnaryMethod_CreateInstancePartition<WithStreamedUnaryMethod_DeleteInstancePartition<WithStreamedUnaryMethod_UpdateInstancePartition<WithStreamedUnaryMethod_ListInstancePartitionOperations<WithStreamedUnaryMethod_MoveInstance<Service > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListInstanceConfigs<WithStreamedUnaryMethod_GetInstanceConfig<WithStreamedUnaryMethod_CreateInstanceConfig<WithStreamedUnaryMethod_UpdateInstanceConfig<WithStreamedUnaryMethod_DeleteInstanceConfig<WithStreamedUnaryMethod_ListInstanceConfigOperations<WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_ListInstancePartitions<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_UpdateInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_GetInstancePartition<WithStreamedUnaryMethod_CreateInstancePartition<WithStreamedUnaryMethod_DeleteInstancePartition<WithStreamedUnaryMethod_UpdateInstancePartition<WithStreamedUnaryMethod_ListInstancePartitionOperations<WithStreamedUnaryMethod_MoveInstance<Service > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace instance
}  // namespace admin
}  // namespace spanner
}  // namespace google


#endif  // GRPC_google_2fspanner_2fadmin_2finstance_2fv1_2fspanner_5finstance_5fadmin_2eproto__INCLUDED
